/* 
 *  Item
 *
 *  Item is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Foobar is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY ); without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 **********************************************************************************
 *  WARNING: THIS CODE WAS GENERATED DO NOT MODIFY, CHANGE THE XSD INSTEAD
 *  Generated by schema2code on Tue Jun 14 15:34:00 2016.
 **********************************************************************************
 *  Copyright 2010
 *
 */

package ivef;

import java.util.*;
import java.text.DecimalFormat;
import java.text.DateFormat;
import java.text.SimpleDateFormat;


public class Item { 

    private int m_dataSelector; // default value is uninitialized
    private boolean m_dataSelectorPresent;
    private String m_fieldSelector; // default value is uninitialized
    private boolean m_fieldSelectorPresent;

    public Item() {

        m_dataSelectorPresent = false;
        m_fieldSelectorPresent = false;
    }

    public Item(Item val) {

        m_dataSelector = val.getDataSelector();
        if (val != null) {
            m_dataSelectorPresent = true;
        }
        m_fieldSelector = val.getFieldSelector();
        if (val != null) {
            m_fieldSelectorPresent = true;
        }
    }

    public boolean setDataSelector(int val) {

        if ( ( val != 1 ) &&
             ( val != 2 ) &&
             ( val != 3 ) )
            return false;
        m_dataSelectorPresent = true;
        m_dataSelector = val;
        return true;
    }

    public int getDataSelector() {

        return m_dataSelector;
    }

    public boolean setFieldSelector(String val) {

        if (val.length() < 1)
          return false;
        if (val.length() > 42)
          return false;
        m_fieldSelectorPresent = true;
        m_fieldSelector = val;
        return true;
    }

    public String getFieldSelector() {

        return m_fieldSelector;
    }

    public String toXML() {

       return toXML(true);

    }

    public String toXML(boolean outputNamespace) {

        String xml = "<Item";
        if (outputNamespace) {
            xml += " xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"";
            xml += " xmlns=\"http://www.iala-to-be-confirmed.org/XMLSchema/IVEF/0.2.5\"";
        };

        DateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        df.setTimeZone(TimeZone.getTimeZone("UTC"));
        DecimalFormat nf = new DecimalFormat();
        nf.setMinimumFractionDigits(6);
        nf.setGroupingSize(0);

        if ( m_dataSelectorPresent ) {
            xml += " DataSelector=\"" + m_dataSelector + "\"";
        } else { 
            return null; // not all required attributes have been set 
        } 
        if ( m_fieldSelectorPresent ) {
            xml += " FieldSelector=\"" + encode( m_fieldSelector) + "\"";
        } else { 
            return null; // not all required attributes have been set 
        } 
        xml += "/>\n";
        return xml;
    }

    public String toString(String lead) {

        String str = lead + "Item\n";
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        df.setTimeZone(TimeZone.getTimeZone("UTC"));
        DecimalFormat nf = new DecimalFormat();
        nf.setMinimumFractionDigits(6);
        nf.setGroupingSize(0);

            str +=  lead + "    DataSelector = " + m_dataSelector + "\n";
            str +=  lead + "    FieldSelector = " + m_fieldSelector + "\n";
        return str;
    }
    public String encode( String str) {

        str = str.replaceAll("&", "&amp;");
        str = str.replaceAll("<", "&lt;");
        str = str.replaceAll(">", "&gt;");
        str = str.replaceAll("\"", "&quot;");
        return str;
    }


}
