/* 
 *  LoginResponse
 *
 *  LoginResponse is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Foobar is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY ); without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 **********************************************************************************
 *  WARNING: THIS CODE WAS GENERATED DO NOT MODIFY, CHANGE THE XSD INSTEAD
 *  Generated by schema2code on Tue Jun 14 15:34:00 2016.
 **********************************************************************************
 *  Copyright 2010
 *
 */

package ivef;

import java.util.*;
import java.text.DecimalFormat;
import java.text.DateFormat;
import java.text.SimpleDateFormat;


public class LoginResponse { 

    private String m_reason; // default value is uninitialized
    private boolean m_reasonPresent;
    private String m_responseOn; // default value is uninitialized
    private boolean m_responseOnPresent;
    private int m_result; // default value is uninitialized
    private boolean m_resultPresent;

    public LoginResponse() {

        m_reasonPresent = false;
        m_responseOnPresent = false;
        m_resultPresent = false;
    }

    public LoginResponse(LoginResponse val) {

        m_reason = val.getReason();
        if (val != null) {
            m_reasonPresent = true;
        }
        m_responseOn = val.getResponseOn();
        if (val != null) {
            m_responseOnPresent = true;
        }
        m_result = val.getResult();
        if (val != null) {
            m_resultPresent = true;
        }
    }

    public boolean setReason(String val) {

        if (val.length() > 256)
          return false;
        m_reasonPresent = true;
        m_reason = val;
        return true;
    }

    public String getReason() {

        return m_reason;
    }

    public boolean hasReason() {

        return m_reasonPresent;
    }

    public boolean setResponseOn(String val) {

        if (val.length() < 36)
          return false;
        if (val.length() > 42)
          return false;
        m_responseOnPresent = true;
        m_responseOn = val;
        return true;
    }

    public String getResponseOn() {

        return m_responseOn;
    }

    public boolean setResult(int val) {

        if ( ( val != 1 ) &&
             ( val != 2 ) )
            return false;
        m_resultPresent = true;
        m_result = val;
        return true;
    }

    public int getResult() {

        return m_result;
    }

    public String toXML() {

       return toXML(true);

    }

    public String toXML(boolean outputNamespace) {

        String xml = "<LoginResponse";
        if (outputNamespace) {
            xml += " xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"";
            xml += " xmlns=\"http://www.iala-to-be-confirmed.org/XMLSchema/IVEF/0.2.5\"";
        };

        DateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        df.setTimeZone(TimeZone.getTimeZone("UTC"));
        DecimalFormat nf = new DecimalFormat();
        nf.setMinimumFractionDigits(6);
        nf.setGroupingSize(0);

        if ( hasReason() ) {
            xml += " Reason=\"" + encode( m_reason) + "\"";
        }
        if ( m_responseOnPresent ) {
            xml += " ResponseOn=\"" + encode( m_responseOn) + "\"";
        } else { 
            return null; // not all required attributes have been set 
        } 
        if ( m_resultPresent ) {
            xml += " Result=\"" + m_result + "\"";
        } else { 
            return null; // not all required attributes have been set 
        } 
        xml += "/>\n";
        return xml;
    }

    public String toString(String lead) {

        String str = lead + "LoginResponse\n";
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        df.setTimeZone(TimeZone.getTimeZone("UTC"));
        DecimalFormat nf = new DecimalFormat();
        nf.setMinimumFractionDigits(6);
        nf.setGroupingSize(0);

        if ( hasReason() ) {
            str +=  lead + "    Reason = " + m_reason + "\n";
        }
            str +=  lead + "    ResponseOn = " + m_responseOn + "\n";
            str +=  lead + "    Result = " + m_result + "\n";
        return str;
    }
    public String encode( String str) {

        str = str.replaceAll("&", "&amp;");
        str = str.replaceAll("<", "&lt;");
        str = str.replaceAll(">", "&gt;");
        str = str.replaceAll("\"", "&quot;");
        return str;
    }


}
