/* 
 *  Transmission
 *
 *  Transmission is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Foobar is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY ); without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 **********************************************************************************
 *  WARNING: THIS CODE WAS GENERATED DO NOT MODIFY, CHANGE THE XSD INSTEAD
 *  Generated by schema2code on Tue Jun 14 15:34:00 2016.
 **********************************************************************************
 *  Copyright 2010
 *
 */

package ivef;

import java.util.*;
import java.text.DecimalFormat;
import java.text.DateFormat;
import java.text.SimpleDateFormat;


public class Transmission { 

    private int m_type; // default value is uninitialized
    private boolean m_typePresent;
    private double m_period; // default value is uninitialized
    private boolean m_periodPresent;

    public Transmission() {

        m_typePresent = false;
        m_periodPresent = false;
    }

    public Transmission(Transmission val) {

        m_type = val.getType();
        if (val != null) {
            m_typePresent = true;
        }
        m_period = val.getPeriod();
        if (val != null) {
            m_periodPresent = true;
        }
    }

    public boolean setType(int val) {

        if ( ( val != 1 ) &&
             ( val != 2 ) &&
             ( val != 3 ) )
            return false;
        m_typePresent = true;
        m_type = val;
        return true;
    }

    public int getType() {

        return m_type;
    }

    public boolean setPeriod(double val) {

        m_periodPresent = true;
        m_period = val;
        return true;
    }

    public double getPeriod() {

        return m_period;
    }

    public boolean hasPeriod() {

        return m_periodPresent;
    }

    public String toXML() {

       return toXML(true);

    }

    public String toXML(boolean outputNamespace) {

        String xml = "<Transmission";
        if (outputNamespace) {
            xml += " xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"";
            xml += " xmlns=\"http://www.iala-to-be-confirmed.org/XMLSchema/IVEF/0.2.5\"";
        };

        DateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        df.setTimeZone(TimeZone.getTimeZone("UTC"));
        DecimalFormat nf = new DecimalFormat();
        nf.setMinimumFractionDigits(6);
        nf.setGroupingSize(0);

        if ( m_typePresent ) {
            xml += " Type=\"" + m_type + "\"";
        } else { 
            return null; // not all required attributes have been set 
        } 
        if ( hasPeriod() ) {
            xml += " Period=\"" + nf.format(m_period) + "\"";
        }
        xml += "/>\n";
        return xml;
    }

    public String toString(String lead) {

        String str = lead + "Transmission\n";
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        df.setTimeZone(TimeZone.getTimeZone("UTC"));
        DecimalFormat nf = new DecimalFormat();
        nf.setMinimumFractionDigits(6);
        nf.setGroupingSize(0);

            str +=  lead + "    Type = " + m_type + "\n";
        if ( hasPeriod() ) {
            str +=  lead + "    Period = " + nf.format(m_period) + "\n";
        }
        return str;
    }
    public String encode( String str) {

        str = str.replaceAll("&", "&amp;");
        str = str.replaceAll("<", "&lt;");
        str = str.replaceAll(">", "&gt;");
        str = str.replaceAll("\"", "&quot;");
        return str;
    }


}
