/* 
 *  ILIdentifier
 *
 *  ILIdentifier is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Foobar is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY ); without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 **********************************************************************************
 *  WARNING: THIS CODE WAS GENERATED DO NOT MODIFY, CHANGE THE XSD INSTEAD
 *  Generated by schema2code on Tue Jun 14 15:34:00 2016.
 **********************************************************************************
 *  Copyright 2010
 *
 */

#import <Foundation/Foundation.h>
#import "ILOtherId.h"
#import "ILOtherName.h"

//-----------------------------------------------------------
//! \brief       Class definition of ILIdentifier
//!
//! (local) Identification of vessel
//!

@interface ILIdentifier : NSObject { 
    NSMutableArray *m_otherIds;
    BOOL m_otherIdPresent;
    NSMutableArray *m_otherNames;
    BOOL m_otherNamePresent;
    NSString *m_callsign;
    BOOL m_callsignPresent;
    int m_IMO;
    BOOL m_IMOPresent;
    NSString *m_name;
    BOOL m_namePresent;
    NSString *m_formerName;
    BOOL m_formerNamePresent;
    NSString *m_flag;
    BOOL m_flagPresent;
    NSString *m_owner;
    BOOL m_ownerPresent;
    int m_MMSI;
    BOOL m_MMSIPresent;
    NSString *m_LRIT;
    BOOL m_LRITPresent;
}

//!Remover for OtherId
//!
-(BOOL) removeOtherId:(ILOtherId *) val;
//!Setter for OtherId
//!
-(BOOL) addOtherId:(ILOtherId *) val;
//!Getter for OtherId
//!
-(ILOtherId *) otherIdAt:(int) i;
//!Element counter for OtherId
//!
-(int) countOfOtherIds;
//!Get all elements for OtherId
//!
-(NSArray *) otherIds;
//!Remover for OtherName
//!
-(BOOL) removeOtherName:(ILOtherName *) val;
//!Setter for OtherName
//!
-(BOOL) addOtherName:(ILOtherName *) val;
//!Getter for OtherName
//!
-(ILOtherName *) otherNameAt:(int) i;
//!Element counter for OtherName
//!
-(int) countOfOtherNames;
//!Get all elements for OtherName
//!
-(NSArray *) otherNames;

/* Callsign:
   Callsign of the target, in accordance with Article 19, Section III of the ITU Radio Regulations (RR) */
//!Setter for Callsign
//!
-(BOOL) setCallsign:(NSString *) val;
//!Getter for Callsign
//!
-(NSString *) callsign;
//!Test for pressence of Callsign
//!
-(BOOL) hasCallsign;

/* IMO:
   IMO number of the target */
//!Setter for IMO
//!
-(BOOL) setIMO:(int) val;
//!Getter for IMO
//!
-(int) IMO;
//!Test for pressence of IMO
//!
-(BOOL) hasIMO;

/* Name:
   Name of the target */
//!Setter for Name
//!
-(BOOL) setName:(NSString *) val;
//!Getter for Name
//!
-(NSString *) name;
//!Test for pressence of Name
//!
-(BOOL) hasName;

/* FormerName:
   Previous name of the target */
//!Setter for FormerName
//!
-(BOOL) setFormerName:(NSString *) val;
//!Getter for FormerName
//!
-(NSString *) formerName;
//!Test for pressence of FormerName
//!
-(BOOL) hasFormerName;

/* Flag:
   The country flag (ISO 3166-1-alpha2) */
//!Setter for Flag
//!
-(BOOL) setFlag:(NSString *) val;
//!Getter for Flag
//!
-(NSString *) flag;
//!Test for pressence of Flag
//!
-(BOOL) hasFlag;

/* Owner:
   Name of owner the target */
//!Setter for Owner
//!
-(BOOL) setOwner:(NSString *) val;
//!Getter for Owner
//!
-(NSString *) owner;
//!Test for pressence of Owner
//!
-(BOOL) hasOwner;

/* MMSI:
   MMSI number of the target */
//!Setter for MMSI
//!
-(BOOL) setMMSI:(int) val;
//!Getter for MMSI
//!
-(int) MMSI;
//!Test for pressence of MMSI
//!
-(BOOL) hasMMSI;

/* LRIT:
   LRIT identification */
//!Setter for LRIT
//!
-(BOOL) setLRIT:(NSString *) val;
//!Getter for LRIT
//!
-(NSString *) LRIT;
//!Test for pressence of LRIT
//!
-(BOOL) hasLRIT;
//!Set attributes by providing a key/value dictionary
//!

-(BOOL) setAttributes:(NSDictionary *)attributeDict;
//!Get attributes as a key/value dictionary
//!
-(NSDictionary *) attributes;
//!Get a XML representation of this class
//!returns nil if not all required fields are set
//!
-(NSString *) XML;
//!Get a string representation of this class
//!
-(NSString *) stringValue;
-(NSString *) stringValueWithLead:(NSString *) lead;
//!Helper routine to encode any string to an XML escaped string
//!
-(NSString *) encode: (NSString *) input;

@end



